# CSE 454
# Assignment #1: Spam or Ham?
# This script will compare the results of student-built classifiers to the answer key
# of human classified results.
# 
# Usage: This script should be run from the directory containing the key.csv file as well as the csv file
# containing your results. Please pass the name of your results csv file as a command line arg to this script.
# 
# For example, from the Linux/Mac command line, run:
# python compare_results.py my_results.csv
 

import sys, csv

proposed_classification_filename = sys.argv[1] # get filename from command line args

key = []
with open('key.csv') as csvfile: # read answer key from file
	key_reader = csv.reader(csvfile)
	for row in key_reader:
		key.append(row)

proposed_classification = [] 
with open(proposed_classification_filename) as csvfile: # read student result from file
	pc_reader = csv.reader(csvfile)
	for row in pc_reader:
		proposed_classification.append(row)

proposed_classification = map(lambda row: (row[0], str(row[1])), proposed_classification) # convert 0 and 1 to string

true_positive = int(sum(map(lambda x: key[x][1] == '1' and proposed_classification[x][1] == '1', range(0, len(key)))))
false_positive = int(sum(map(lambda x: key[x][1] == '0' and proposed_classification[x][1] == '1', range(0, len(key)))))
true_negative = int(sum(map(lambda x: key[x][1] == '0' and proposed_classification[x][1] == '0', range(0, len(key)))))
false_negative = int(sum(map(lambda x: key[x][1] == '1' and proposed_classification[x][1] == '0', range(0, len(key)))))
percent_correctly_classified = float(true_positive + true_negative) / float(true_positive + true_negative + false_positive + false_negative)

print "Spam emails are considered positive results, ham emails are considered negative results."
print "True Positives (i.e. correctly flagged as spam): " + str(true_positive)
print "False Positives (i.e. incorrectly flagged as spam): " + str(false_positive)
print "True Negatives (i.e. ham that was correctly identified): " + str(true_negative)
print "False Negatives (i.e. spam that snuck through the filter): " + str(false_negative)

print "Total percentage of emails which were correctly classified: " + str(percent_correctly_classified)